# BEGIN SourceDeps(oneline):
BuildRequires: perl(Class/Accessor/Grouped.pm) perl(DBD/SQLite.pm) perl(DBIx/Class.pm) perl(DBIx/Class/Core.pm) perl(DBIx/Class/Result/ColumnData.pm) perl(DBIx/Class/ResultSet.pm) perl(DBIx/Class/Schema.pm) perl(DateTime.pm) perl(DateTime/Format/SQLite.pm) perl(Exporter.pm) perl(Module/Build.pm) perl(SQL/Translator.pm) perl(Test/More.pm) perl(base.pm) perl(DBIx/Class/IntrospectableM2M.pm)
# END SourceDeps(oneline)
%define module_version 0.03
%define module_name DBIx-Class-Result-ProxyField
%define _unpackaged_files_terminate_build 1
BuildRequires: rpm-build-perl perl-devel perl-podlators

Name: perl-%module_name
Version: 0.03
Release: alt1
Summary: DBIx Class Result ProxyField
Group: Development/Perl
License: perl
Url: %CPAN %module_name

Source0: http://cpan.org.ua/authors/id/N/NO/NOUDARD/%module_name-%module_version.tar.gz
BuildArch: noarch

%description
First, this module would evolve, it is not completly finished

To use Result::ProxyField component, you need to declare it in Result and ResultSet of your DBIx::Class object

in your Result :

    package App::Schema::Result::Object;

    # declare columns : for each column you want use an other name, declare public_name

    __PACKAGE__->add_columns(
      "superobjectid",
      { data_type => "integer", is_nullable => 1, public_name => 'super_object_id' },
      "actif",
      { data_type => "tinyint", default_value => 1, is_nullable => 1 },
      "creation_datetime",
      { data_type => "datetime", is_nullable => 1, public_name => 'created_at'}
    );

    # after declare columns you can initialise the Result::ProxyField component

    __PACKAGE__->load_component(qw/Result::ProxyField/);
    __PACKAGE__->init_proxy_field();

in your ResultSet

    package App::Schema::ResultSet::Object;
    use base 'DBIx::Class::ResultSet::ProxyField';

On your code, you can use public_name to set or get column

    my $schema = App::Schema->connect('dbi:SQLite:db/example.db');

    my @objects = $schema->resultset('Object')->search({created_at => {"==", undef},super_object_id => 1});
    # is the same than
    my @objects = $schema->resultset('Object')->search({creation_datetime => {"==", undef}, superobjectid => 1});

    my $object = $objects[0];

    $object->created_at(DateTime.now());
    #is the same than
    $object->creation_datetime(DateTime.now());

    my $created_at = $object->created_at;
    #is the same than
    my $created_at = $object->creation_datetime;

    ...etc

becareful, the relationship id stay superobjectid


%prep
%setup -n %module_name-%module_version

%build
%perl_vendor_build

%install
%perl_vendor_install

%files
%doc README Changes
%perl_vendor_privlib/D*

%changelog
* Mon Oct 14 2013 Igor Vlasenko <viy@altlinux.ru> 0.03-alt1
- initial import by package builder

